/*
 * queue.c
 *
 * Implementation of queue manipulation functions
 * 
 */


#include <stdio.h>
#include <stdlib.h>
#include "queue.h"


queue_t* queue_create()
{
   queue_t *queue;
   queue = (queue_t*) malloc(sizeof(queue_t));
   queue->first = NULL;
   queue->last = NULL;
   return queue;
}


int queue_destroy(queue_t *queue)
{
   if (queue == NULL ) {
      return 0;
   }
   if (queue->first != NULL) {
      return -1;
   } else {
      free(queue);
      return 0;
   }
}


void queue_enqueue(queue_t *queue, struct _sthread *thread)
{
   if (queue == NULL || thread == NULL) {
      return;
   }

   queue_element_t *new_element;
   new_element = (queue_element_t*) malloc(sizeof(queue_element_t));
   new_element->thread = thread;
   new_element->next = NULL;

   if(queue->first == NULL) {
      queue->first = new_element;
      queue->last = new_element;
   } else {
      queue->last->next = new_element;
      queue->last = new_element;
   }
}


int queue_is_empty(queue_t *queue)
{
   if (queue == NULL || queue->first == NULL) {
      return 1;
   } else {
      return 0;
   }
}


struct _sthread *queue_first(queue_t *queue)
{
   if (queue != NULL && queue->first != NULL) {
      return queue->first->thread;
   } else {
      return NULL;
   }
}


struct _sthread *queue_dequeue(queue_t *queue)
{
   if (queue == NULL || queue->first == NULL) {
      return NULL;
   }
   
   queue_element_t *out_element = queue->first;
   if (queue->first == queue->last) {
      queue->first = NULL;
      queue->last = NULL;
   } else {
      queue->first = out_element->next;
   }
   
   struct _sthread *thread = out_element->thread;
   free(out_element);
   return thread;
}
